#!/usr/bin/perl -w
use strict;

my %hit = ();
while (<>) {
    chomp;
    if (/^\s*$/) { print $_ . "\n"; next; }
    if (/^\#/) { print $_ . "\n"; next; }
    my ($p, $lhs, @rhs) = split;
    if (@rhs <= 2) { print $_ . "\n"; next; }
    # need to binarize this rule
    my $n = 1;
    print "$p $lhs $rhs[0] $rhs[1]";
    for (my $i=2; $i<@rhs; $i++) { print "__" . $rhs[$i]; }
    print "\n";

    for (my $i=1; $i<@rhs-1; $i++) {
        my $this = $rhs[$i];
        for (my $j=$i+1; $j<@rhs; $j++) { $this .= "__" . $rhs[$j]; }
        if (exists $hit{$this}) { last; }
        $hit{$this} = 1;
        print "1.0 $this $rhs[$i] " . $rhs[$i+1];
        for (my $j=$i+2; $j<@rhs; $j++) { print "__" . $rhs[$j]; }
        print "\n";
    }
}

    
